#include <mp4lib/mp4.h>

/* Okay. I have no idea how the fuck this code works, but I can't find
   any information that'd be useful to even start making my own
   algorithm. So, lifted and dropped wholesale, with minor cosmetic
   changes to the coding style: */
int esds_length(FILE *fh, atom_t *atom)
{
  u_int8_t b;
  u_int8_t numBytes = 0;
  u_int32_t length = 0;

  do {
    fread(&b, 1, 1, fh);
    atom->pos++;
    numBytes++;
    length = (length << 7) | (b & 0x7F);
  } while ((b & 0x80) && numBytes < 4);

  return length;
}


int get_esds(FILE *fh, esds_t *esds, atom_t *atom)
{
  unsigned char Buf[4];
  unsigned char bigBuf[13];

#ifdef DEBUG
  printf("Current file position %08X\n", ftell(fh));
#endif
  ff_atom(fh, atom, 4); /* Skip version, flags */

  /* ES descriptor tag and length */
  if ((fread(Buf, 1, 1, fh)) < 1) {
    return 0;
  }
  atom->pos++;
  if (Buf[0] != 0x03) {
    return 0;
  }
  if (esds_length(fh, atom) < 20) {
    return 0;
  }

  /* ES ID */
  if ((fread(Buf, 1, 2, fh)) < 2) {
    esds->esid = 0;
    return 0;
  }
  esds->esid = str2int(Buf, 2);
  atom->pos += 2;

  /* Stream priority */
  if ((fread(Buf, 1, 1, fh)) < 1) {
    esds->priority = 0;
    return 0;
  }
  esds->priority = Buf[0];
  atom->pos++;

  /* Decoder descriptor tag and length */
  if ((fread(Buf, 1, 1, fh)) < 1) {
    return 0;
  }
  atom->pos++;
  if (Buf[0] != 0x04) {
    return 0;
  }
  if (esds_length(fh, atom) < 15) {
    return 0;
  }

  /* Object type ID, stream config, buffer size, and bit rates */
  if ((fread(bigBuf, 1, 13, fh)) < 13) {
    esds->obj_type = 0;
    esds->stream_info = 0;
    esds->buffersize = 0;
    esds->max_bitrate = 0;
    esds->avg_bitrate = 0;
    return 0;
  }
  atom->pos += 13;
  esds->obj_type = bigBuf[0];
  esds->stream_info = bigBuf[1];
  esds->buffersize = str2int(bigBuf + 2, 3);
  esds->max_bitrate = str2int(bigBuf + 5, 4);
  esds->avg_bitrate = str2int(bigBuf + 9, 4);

  /* Decoder-specific info descriptor tag and length */
  /* This is what we hand to libfaad so it knows how to configure
     the AAC decoder. */
  if ((fread(Buf, 1, 1, fh)) < 1) {
    return 0;
  }
  atom->pos++;
  if (Buf[0] != 0x05) {
    return 0;
  }
  esds->dConfLen = esds_length(fh, atom);

  /* Okay. Now we know how long the configuration is going to be.
     Allocate the buffer space, load it in. */
  if (!(esds->decConfig = (u_char *) malloc(esds->dConfLen))) {
    /* Crap. Couldn't get the buffer. */
    esds->dConfLen = 0;
    esds->decConfig = NULL;
    return 0;
  }
  if ((fread(esds->decConfig, 1, esds->dConfLen, fh)) < esds->dConfLen) {
    /* Crap. Couldn't get in all the bytes. */
    esds->dConfLen = 0;
    free(esds->decConfig);
    esds->decConfig = NULL;
    return 0;
  }
  atom->pos += esds->dConfLen;

  /* SL config descriptor tag and length */
  /* I don't really know what this is, but it's easy enough to provide
     for, so I may as well load it in too. */
  if ((fread(Buf, 1, 1, fh)) < 1) {
    return 0;
  }
  atom->pos++;
  if (Buf[0] != 0x06) {
    return 0;
  }
  if (!esds_length(fh, atom)) {
    return 0;
  }

  /* SL config */
  if ((fread(Buf, 1, 1, fh)) < 1) {
    esds->SL = 0;
    return 0;
  }
  esds->SL = Buf[0];
  atom->pos++;

  skip_atom(fh, atom);
  esds->got_esds = 1;
#ifdef DEBUG
  printf("Current file position %08X\n", ftell(fh));
#endif
  return 1;
}

void init_esds(esds_t *esds)
{
  esds->got_esds = 0;

  esds->esid = 0;
  esds->priority = 0;

  esds->obj_type = 0;
  esds->stream_info = 0;
  esds->buffersize = 0;
  esds->max_bitrate = 0;
  esds->avg_bitrate = 0;

  esds->dConfLen = 0;
  esds->decConfig = NULL;

  esds->SL = 0;
}

void clear_esds(esds_t *esds)
{
  esds->got_esds = 0;

  esds->esid = 0;
  esds->priority = 0;

  esds->obj_type = 0;
  esds->stream_info = 0;
  esds->buffersize = 0;
  esds->max_bitrate = 0;
  esds->avg_bitrate = 0;

  esds->dConfLen = 0;
  free(esds->decConfig);
  esds->decConfig = NULL;

  esds->SL = 0;
}
