#include <mp4lib/mp4.h>

int get_mdia(FILE *fh, mdia_t *mdia, atom_t *atom)
{
  atom_t child_atom;

  do {
    atom_head(fh, &child_atom);

    if (atomid(child_atom.name) == atomid("mdhd")) {
      get_mdhd(fh, &(mdia->mdhd), &child_atom);
    } else if (atomid(child_atom.name) == atomid("hdlr")) {
      get_hdlr(fh, &(mdia->hdlr), &child_atom);
    } else if (atomid(child_atom.name) == atomid("minf")) {
      get_minf(fh, &(mdia->minf), &child_atom);
    } else {
      skip_atom(fh, &child_atom);
    }
    atom->pos += child_atom.size;
  } while (atom->pos < atom->size);

  skip_atom(fh, atom);
  return 1;
}

void init_mdia(mdia_t *mdia)
{
  init_mdhd(&(mdia->mdhd));
  init_hdlr(&(mdia->hdlr));
}

void clear_mdia(mdia_t *mdia)
{
  init_mdhd(&(mdia->mdhd));
  init_hdlr(&(mdia->hdlr));
}
