#include <mp4lib/mp4.h>

int get_minf(FILE *fh, minf_t *minf, atom_t *atom)
{
  atom_t child_atom;

  do {
    atom_head(fh, &child_atom);

    if (atomid(child_atom.name) == atomid("smhd")) {
      get_smhd(fh, &(minf->smhd), &child_atom);
    } else if (atomid(child_atom.name) == atomid("stbl")) {
      get_stbl(fh, &(minf->stbl), &child_atom);
/*    } else if (atomid(child_atom.name) == atomid("CHILD2")) { */
/*      get_CHILD2(fh, &(minf->CHILD2), &child_atom); */
    } else {
      skip_atom(fh, &child_atom);
    }
    atom->pos += child_atom.size;
  } while (atom->pos < atom->size);

  skip_atom(fh, atom);
  return 1;
}

void init_minf(minf_t *minf)
{
  init_smhd(&(minf->smhd));
  init_stbl(&(minf->stbl));
}

void clear_minf(minf_t *minf)
{
  init_smhd(&(minf->smhd));
  clear_stbl(&(minf->stbl));
}
