#include <mp4lib/mp4.h>

int get_stbl(FILE *fh, stbl_t *stbl, atom_t *atom)
{
  atom_t child_atom;

  do {
    atom_head(fh, &child_atom);

    if (atomid(child_atom.name) == atomid("stsd")) {
      get_stsd(fh, &(stbl->stsd), &child_atom);
      skip_atom(fh, &child_atom);
    } else if (atomid(child_atom.name) == atomid("stts")) {
      get_stts(fh, &(stbl->stts), &child_atom);
    } else if (atomid(child_atom.name) == atomid("stsc")) {
      get_stsc(fh, &(stbl->stsc), &child_atom);
    } else if (atomid(child_atom.name) == atomid("stsz")) {
      get_stsz(fh, &(stbl->stsz), &child_atom);
    } else if (atomid(child_atom.name) == atomid("stco")) {
      get_stco(fh, &(stbl->stco), &child_atom);
/*    } else if (atomid(child_atom.name) == atomid("CHILD2")) { */
/*      get_CHILD2(fh, &(stbl->CHILD2), &child_atom); */
    } else {
      skip_atom(fh, &child_atom);
    }
    atom->pos += child_atom.size;
  } while (atom->pos < atom->size);

  skip_atom(fh, atom);
  return 1;
}

void init_stbl(stbl_t *stbl)
{
  init_stsd(&(stbl->stsd));
}

void clear_stbl(stbl_t *stbl)
{
  clear_stsd(&(stbl->stsd));
}
