#include <mp4lib/mp4.h>

void init_stco_t(stco_t_t *t)
{
  t->offset = 0;
}

int get_stco_t(FILE *fh, stco_t_t *t, atom_t *atom)
{
  unsigned char Buf[4];

  if ((fread(Buf, 1, 4, fh)) < 4) {
    t->offset = 0;
    return 0;
  }
  t->offset = str2int(Buf, 4);
  atom->pos += 4;
}

int get_stco(FILE *fh, stco_t *stco, atom_t *atom)
{
  unsigned char Buf[4];
  u_int32_t i;

#ifdef DEBUG
  printf("Current file position %08X\n", ftell(fh));
#endif
  ff_atom(fh, atom, 4); /* Skip version, flags */
  if ((fread(Buf, 1, 4, fh)) < 4) {
    stco->entries = 0;
    return 0;
  }
  stco->entries = str2int(Buf, 4);
  atom->pos += 4;
  stco->t = (stco_t_t *) malloc(sizeof(stco_t_t) * stco->entries);
  for (i = 0; i < stco->entries; i++) {
    init_stco_t(&(stco->t[i]));
    get_stco_t(fh, &(stco->t[i]), atom);
  }

  skip_atom(fh, atom);
#ifdef DEBUG
  printf("Current file position %08X\n", ftell(fh));
#endif
  return 1;
}

void init_stco(stco_t *stco)
{
  stco->entries = 0;
  stco->t = NULL;
}

void clear_stco(stco_t *stco)
{
  if (stco->entries) {
    free(stco->t);
  }
  stco->entries = 0;
  stco->t = NULL;
}
