#include <mp4lib/mp4.h>

void init_stsc_t(stsc_t_t *t)
{
  t->chunk = 0;
  t->samples = 0;
  t->id = 0;
}

int get_stsc_t(FILE *fh, stsc_t_t *t, atom_t *atom)
{
  unsigned char Buf[4];

  if ((fread(Buf, 1, 4, fh)) < 4) {
    t->chunk = 0;
    return 0;
  }
  t->chunk = str2int(Buf, 4);
  atom->pos += 4;
  if ((fread(Buf, 1, 4, fh)) < 4) {
    t->samples = 0;
    return 0;
  }
  t->samples = str2int(Buf, 4);
  atom->pos += 4;
  if ((fread(Buf, 1, 4, fh)) < 4) {
    t->id = 0;
    return 0;
  }
  t->id = str2int(Buf, 4);
  atom->pos += 4;
}

int get_stsc(FILE *fh, stsc_t *stsc, atom_t *atom)
{
  unsigned char Buf[4];
  u_int32_t i;

#ifdef DEBUG
  printf("Current file position %08X\n", ftell(fh));
#endif
  ff_atom(fh, atom, 4); /* Skip version, flags */
  if ((fread(Buf, 1, 4, fh)) < 4) {
    stsc->entries = 0;
    return 0;
  }
  stsc->entries = str2int(Buf, 4);
  atom->pos += 4;
  stsc->t = (stsc_t_t *) malloc(sizeof(stsc_t_t) * stsc->entries);
  for (i = 0; i < stsc->entries; i++) {
    init_stsc_t(&(stsc->t[i]));
    get_stsc_t(fh, &(stsc->t[i]), atom);
  }

  skip_atom(fh, atom);
#ifdef DEBUG
  printf("Current file position %08X\n", ftell(fh));
#endif
  return 1;
}

void init_stsc(stsc_t *stsc)
{
  stsc->entries = 0;
  stsc->t = NULL;
}

void clear_stsc(stsc_t *stsc)
{
  if (stsc->entries) {
    free(stsc->t);
  }
  stsc->entries = 0;
  stsc->t = NULL;
}
