#include <mp4lib/mp4.h>

void init_stts_t(stts_t_t *t)
{
  t->count = 0;
  t->duration = 0;
}

int get_stts_t(FILE *fh, stts_t_t *t, atom_t *atom)
{
  unsigned char Buf[4];

  if ((fread(Buf, 1, 4, fh)) < 4) {
    t->count = 0;
    return 0;
  }
  t->count = str2int(Buf, 4);
  atom->pos += 4;
  if ((fread(Buf, 1, 4, fh)) < 4) {
    t->duration = 0;
    return 0;
  }
  t->duration = str2int(Buf, 4);
  atom->pos += 4;
}

int get_stts(FILE *fh, stts_t *stts, atom_t *atom)
{
  unsigned char Buf[4];
  u_int32_t i;

#ifdef DEBUG
  printf("Current file position %08X\n", ftell(fh));
#endif
  ff_atom(fh, atom, 4); /* Skip version, flags */
  if ((fread(Buf, 1, 4, fh)) < 4) {
    stts->entries = 0;
    return 0;
  }
  stts->entries = str2int(Buf, 4);
  atom->pos += 4;
  stts->t = (stts_t_t *) malloc(sizeof(stts_t_t) * stts->entries);
  for (i = 0; i < stts->entries; i++) {
    init_stts_t(&(stts->t[i]));
    get_stts_t(fh, &(stts->t[i]), atom);
  }

  skip_atom(fh, atom);
#ifdef DEBUG
  printf("Current file position %08X\n", ftell(fh));
#endif
  return 1;
}

void init_stts(stts_t *stts)
{
  stts->entries = 0;
  stts->t = NULL;
}

void clear_stts(stts_t *stts)
{
  if (stts->entries) {
    free(stts->t);
  }
  stts->entries = 0;
  stts->t = NULL;
}
