#include <mp4lib/mp4.h>

int get_tkhd(FILE *fh, tkhd_t *tkhd, atom_t *atom)
{
  atom_t child_atom;
  unsigned char Buf[4];

  ff_atom(fh, atom, 12); /* Skip version, flags, create/mod times */
  if ((fread(Buf, 1, 4, fh)) < 4) {
    tkhd->track_id = 0;
    return 0;
  }
  tkhd->track_id = str2int(Buf, 4);
  atom->pos += 4;
  ff_atom(fh, atom, 4); /* Skip reserved field */
  if ((fread(Buf, 1, 4, fh)) < 4) {
    tkhd->duration = 0;
    return 0;
  }
  tkhd->duration = str2int(Buf, 4);
  atom->pos += 4;

  skip_atom(fh, atom);
  return 1;
}

void init_tkhd(tkhd_t *tkhd)
{
  tkhd->track_id = 0;
  tkhd->duration = 0;
}
