#include <mp4lib/mp4.h>

int get_trak(FILE *fh, trak_t *trak, atom_t *atom)
{
  atom_t child_atom;

  do {
    atom_head(fh, &child_atom);

    if (atomid(child_atom.name) == atomid("tkhd")) {
      get_tkhd(fh, &(trak->tkhd), &child_atom);
    } else if (atomid(child_atom.name) == atomid("mdia")) {
      get_mdia(fh, &(trak->mdia), &child_atom);
    } else {
      skip_atom(fh, &child_atom);
    }
    atom->pos += child_atom.size;
  } while (atom->pos < atom->size);

  skip_atom(fh, atom);
  return 1;
}

trak_t *add_trak(moov_t *moov) {
  if (moov->tracks < MAXTRACKS) {
    moov->trak[moov->tracks] = (trak_t *) malloc(sizeof(trak_t));
    init_trak(moov->trak[moov->tracks]);
    moov->tracks++;
  }
  return moov->trak[moov->tracks - 1];
}

void init_trak(trak_t *trak)
{
  init_tkhd(&(trak->tkhd));
  init_mdia(&(trak->mdia));
}

int delete_trak(moov_t *moov, trak_t *trak)
{
  int i, j;

  for (i = 0; i < moov->tracks; i++) {
    if (moov->trak[i] == trak) {
      init_tkhd(&(moov->trak[i]->tkhd));
      clear_mdia(&(moov->trak[i]->mdia));
      free(trak);
      moov->trak[i] = 0;
      for (j = i + 1; j < moov->tracks; j++, i++) {
        moov->trak[i] = moov->trak[j];
      }
      moov->trak[j] = 0;
      moov->tracks--;
      return 1;
    }
  }
  return 0;
}
