/*
 * libm4a include file
 */

#ifndef LIBM4A_H
#define LIBM4A_H

/* Pull in other defines */
#if HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#include <stdio.h>
#include <sys/types.h>

#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#elif HAVE_STRINGS_H
#include <strings.h>
#endif

#include <pthread.h>

#include <glib.h>
#include <gtk/gtk.h>
#include <xmms/plugin.h>
#include <xmms/util.h>
#include <xmms/titlestring.h>
#include <xmms/titlestring.h>

#include <faad.h>
#include <mp4lib/mp4.h>

#if !HAVE_STRRCHR
#define strrchr rindex
#endif

/* typedefs and struct defs */

typedef struct _player_t {
  FILE *fh;
  moov_t *moov;
  int playing;
  int time_index;
  int eof;

  /* Pointers to sub-atoms of the moov atom, for easier access */
  trak_t *trak;

  /* Info for file info box */
  gulong samplerate;
  guchar channels;
  guint bitrate;
  guint samples;
} player_t;

extern InputPlugin m4a_ip;
extern player_t *m4a_info;

/* Function prototypes */

/* libm4a.c */
static void m4a_init(void);
static void m4a_about(void);
static int is_m4a_file(char *);
static void play_m4a(char *filename);
static void stop_m4a(void);
static void pause_m4a(short);
static void seek_m4a(int);
static int m4a_get_time(void);
static void get_m4a_info(char *, char **, int *);

/* util.c */
guint get_song_time(moov_t *);
gchar *get_ext(const char *);
gchar *get_song_title(moov_t *, char *);

/* fileinfo.c */
void m4a_info_box(char *);

#endif /* LIBM4A_H */
